=== modified file 'src/com/goldencode/p2j/uast/ClassDefinition.java'
--- old/src/com/goldencode/p2j/uast/ClassDefinition.java	2022-05-16 16:24:45 +0000
+++ new/src/com/goldencode/p2j/uast/ClassDefinition.java	2022-05-23 20:10:15 +0000
@@ -117,6 +117,10 @@
 **     CA  20220428          Annotate THIS-OBJECT and SUPER constructor call parameters.
 **     CA  20220513          Track the Java field name for the builtin enums, so they can emit the exact name.
 **     CA  20220516          Fixed tracking of extent data members (variables or properties).
+**     GES 20210311          Rewrote exact and fuzzy method matching to support all data types and
+**                           overloading rules.  Fixed many latent problems.  Reworked how method names
+**                           convert to resolve conflicts within the class hierarchy instead of project
+**                           wide.
 */
 
 /*
@@ -177,13 +181,15 @@
 import java.lang.reflect.*;
 import java.util.*;
 import java.util.function.*;
+import java.util.stream.Collectors;
+
 import com.goldencode.ast.*;
 import com.goldencode.p2j.convert.*;
 import com.goldencode.p2j.convert.db.*;
 import com.goldencode.p2j.oo.lang.*;
 import com.goldencode.p2j.schema.*;
 import com.goldencode.p2j.util.*;
-import com.goldencode.p2j.util.Utils;
+import com.goldencode.p2j.util.Utils; // conflicts with ANTLR so it needs to be explicitly imported 
 
 import antlr.*;
 
@@ -206,11 +212,6 @@
 public class ClassDefinition
 implements ProgressParserTokenTypes
 {
-   /**
-    * Flag to indicate whether tracing is ON.
-    */
-   public static final boolean nowrapObjects = System.getProperty("nowrap.objects") != null;
-
    /** Data store identifier. */
    protected static enum DataStoreType { VAR, METHOD, TABLE, QRY, DATASET, DATASRC };
 
@@ -230,7 +231,17 @@
    private Map<String, Map<SignatureKey, MemberData>> imethods = null; 
    
    /** Static methods mapped by name. */
-   private Map<String, Map<SignatureKey, MemberData>> smethods = null; 
+   private Map<String, Map<SignatureKey, MemberData>> smethods = null;
+
+   /**
+    * A set of existing Java signatures to detect when there is a method overloading conflict (more than one
+    * method with the same java name and signature).  Some overloaded methods can convert to identical Java
+    * signatures when they are different in the 4GL.
+    */
+   private Set<String> javaMethodCollisions = new HashSet<>();
+
+   /** Lookup of the Java name (known to be unique) from the legacy signature (which also is be unique). */
+   private Map<String, String> legacyToJavaMethod = new HashMap<>();
    
    /** Internal lock object. */
    private Object lock = new Object();
@@ -244,8 +255,11 @@
    /** Super class definition. Only interfaces can have multiple parents. */
    private final ClassDefinition[] parents;
    
+   /** Implemented interfaces. */
+   private final ClassDefinition[] interfaces;
+   
    /** List of implemented interfaces. */
-   private final Set<String> interfaces;
+   private final Set<String> ifaces;
    
    /** Flag marking if this is a built-in Progress class. */
    private final boolean builtin;
@@ -277,17 +291,13 @@
    /** Flag indicating that this class was processed (fully parsed) after it was pre-scanned. */
    private boolean processed = false;
    
-   /**
-    * A map of legacy method signatures to Java names.  This is used for builtin 4GL classes
-    * which are implemented in FWD, so that any references or overridden methods will inherit this 
-    * name.
-    */
-   private Map<String, String> javaMethodNames = new HashMap<>();
+   /** Full Java package in dotted notation (no class name). */
+   private String javaPackage = null;
 
    /** The Java field names for skeleton enums. */
    private Map<String, String> javaEnumNames = new HashMap<>();
    
-   /** The fully qualified converted Java name for this legacy class. */
+   /** Simple Java class name, without any package prefix. */
    private String javaClassName = null;
    
    /**
@@ -317,7 +327,7 @@
     */
    public ClassDefinition(String            name,
                           ClassDefinition[] parents,
-                          Set<String>       interfaces,
+                          ClassDefinition[] interfaces,
                           boolean           builtin,
                           OOType            otype,
                           boolean           dotnet,
@@ -326,10 +336,19 @@
       this.name       = name;
       this.parents    = parents;
       this.interfaces = interfaces;
+      this.ifaces     = (interfaces != null) ? new HashSet<String>() : null;
       this.builtin    = builtin;
       this.otype      = otype;
       this.dotnet     = dotnet;
       this.filename   = filename;
+
+      if (interfaces != null)
+      {
+         for (ClassDefinition iface : interfaces)
+         {
+            ifaces.add(iface.getName());
+         }
+      }
       
       if (builtin && !dotnet)
       {
@@ -369,32 +388,30 @@
       // get from the root
       this.dotnet = Boolean.TRUE.equals(root.getAnnotation("dotnet-cls"));
       this.builtin = Boolean.TRUE.equals(root.getAnnotation("builtin-cls")) && !dotnet;
-      this.otype = root.downPath("INTERFACE_DEF") 
-                     ? OOType.INTERFACE
-                     : root.downPath("ENUM_DEF") 
-                         ? OOType.ENUM 
-                         : OOType.CLASS;
+      this.otype = root.downPath("INTERFACE_DEF") ? OOType.INTERFACE
+                                                  : root.downPath("ENUM_DEF") ? OOType.ENUM : OOType.CLASS;
       if (builtin && !dotnet)
       {
          // this must be before we walk the AST
          loadBuiltinDefinition();
       }
+      
       if (!builtin)
       {
          this.schemaDict = new SchemaDictionary(null);
          this.schemaDict.addScope(false);
          SchemaWorker.loadFromPersistence(schemaDict, filename);
          
-         String pkg = (String) root.getAnnotation("pkgname");
-         String cls = (String) root.getAnnotation("classname");
-         this.javaClassName = pkg + "." + cls;
+         this.javaPackage   = (String) root.getAnnotation("pkgname");
+         this.javaClassName = (String) root.getAnnotation("classname");
       }
       
-      Set<String> interfaces = new HashSet<>();
-      List<ClassDefinition> parents = new ArrayList<>();
+      Set<String>           ifaces     = new HashSet<>();
+      List<ClassDefinition> interfaces = new ArrayList<>();
+      List<ClassDefinition> parents    = new ArrayList<>();
       boolean hadRootClass = false;
 
-      Consumer<String> resolveParent = (pqname) ->
+      BiConsumer<List<ClassDefinition>, String> resolveParent = (list, pqname) ->
       {
          ClassDefinition clsdef = SymbolResolver.loadClassDefinition(sym, pqname);
          if (clsdef == null)
@@ -417,7 +434,8 @@
          {
             throw new RuntimeException("Could not load parent class: " + pqname);
          }
-         parents.add(clsdef);
+         
+         list.add(clsdef);
       };
       
       boolean isIface = this.otype == OOType.INTERFACE;
@@ -438,18 +456,19 @@
 
                if (isIface)
                {
-                  resolveParent.accept(pqname);
+                  resolveParent.accept(parents, pqname);
                }
                else
                {
-                  interfaces.add(pqname);
+                  resolveParent.accept(interfaces, pqname);
+                  ifaces.add(pqname);
                }
                break;
 
             case KW_INHERITS:
                ref = node.getImmediateChild(CLASS_NAME, null);
                pqname = (String) ref.getAnnotation("qualified");
-               resolveParent.accept(pqname);
+               resolveParent.accept(parents, pqname);
                hadRootClass = SymbolResolver.ROOT_OBJ_NAME.equalsIgnoreCase(pqname);
                break;
          }
@@ -460,54 +479,28 @@
             String storeName = (String) node.getAnnotation("oo-data-store");
             DataStoreType storeType = DataStoreType.valueOf(storeName);
             boolean isStatic = Boolean.TRUE.equals(node.getAnnotation("static"));
+            boolean isOverride = Boolean.TRUE.equals(node.getAnnotation("override"));
             
             if (storeType == DataStoreType.METHOD)
             {
-               String name = (String) node.getAnnotation("name");
-               String key = name.toLowerCase();
-               
-               // TODO: move this in common code with addMethod
-               if (imethods == null)
-               {
-                  imethods = new HashMap<>();
-                  smethods = new HashMap<>();
-               }
-
-               Map<String, Map<SignatureKey, MemberData>> store = isStatic ? smethods : imethods;
-               Map<SignatureKey, MemberData>              defs  = store.get(key);
-               if (defs == null)
-               {
-                  defs = new HashMap<>();
-                  store.put(key, defs);
-               }
-               
-               ParameterKey[] sig = SymbolResolver.calculateDefinitionSignature(node);
-               int accessMode = ((Long) node.getAnnotation("access-mode")).intValue();
-               int retType = ((Long) node.getAnnotation("return_type")).intValue();
-               MemberData mdat = createMethod(name,
-                                                sig, 
-                                                accessMode,
-                                                isStatic,
-                                                retType,
-                                                (String) node.getAnnotation("qualified"),
-                                                (String) node.getAnnotation("javaname"),
-                                                SymbolResolver.readExtent(node),
-                                                -1);
-               defs.put(new SignatureKey(sig), mdat);
+               String         name = (String) node.getAnnotation("name");
+               ParameterKey[] sig  = SymbolResolver.calculateDefinitionSignature(node);
+               
+               MemberData mdat = createMethod(null,
+                                              name,
+                                              sig, 
+                                              ((Long) node.getAnnotation("access-mode")).intValue(),
+                                              isStatic,
+                                              ((Long) node.getAnnotation("return_type")).intValue(),
+                                              (String) node.getAnnotation("qualified"),
+                                              (String) node.getAnnotation("javaname"),
+                                              SymbolResolver.readExtent(node),
+                                              -1,
+                                              node.getImmediateChild(KW_OVERRIDE, null) != null,
+                                              node.getImmediateChild(KW_ABSTRACT, null) != null);
                
                if (!builtin)
                {
-                  String legacySignature = SymbolResolver.calculateLegacySignature(name, sig);
-                  String jname = mdat.javaname;
-                  String oldJname = javaMethodNames.put(legacySignature, jname);
-                  if (oldJname != null && !oldJname.equals(jname))
-                  {
-                     // something is wrong... name must match!
-                     System.err.println("ERROR: method " + legacySignature + 
-                                        " accessible from class " + qname + 
-                                        " has two Java names: " + jname + " and " + oldJname);
-                  }
-                  
                   mdat.astId = node.getId();
                   mdat.tempIdx = ConversionData.getTempIdx(mdat.astId);
                }
@@ -629,14 +622,19 @@
                                            tokenType, 
                                            (String) node.getAnnotation("qualified"));
                         tokenType = VAR_CLASS;
+                        
+                        // TODO: for enums, do we need to lookup the javaname in javaEnumNames here or
+                        //       can we rely upon the AST node's "javaname" annotation?
                      }
+                     
                      var.setProperty(nodeType == DEFINE_PROPERTY);
                      var.setStatic(isStatic && !isEnum());
                      var.setAccess(accessMode);
                      var.setExtent(SymbolResolver.readExtent(node));
-
+                     var.setOverride(isOverride);
+                     
                      // we need to know the variable's state at this point
-                     SymbolResolver.trackMethodSignatures(nodeType, var, varName);
+                     SymbolResolver.trackPropertyOrEventMethodSignatures(nodeType, this, node, var, varName);
                      break;
                      
                    default:
@@ -686,10 +684,9 @@
          parents.add(parent);
       }
       
-      this.interfaces = interfaces.isEmpty() ? null : Collections.unmodifiableSet(interfaces);
-      this.parents = parents.isEmpty() 
-                        ? null 
-                        : (ClassDefinition[]) parents.toArray(new ClassDefinition[0]);
+      this.ifaces     = ifaces.isEmpty() ? null : Collections.unmodifiableSet(ifaces);
+      this.interfaces = interfaces.isEmpty() ? null : interfaces.toArray(new ClassDefinition[0]);
+      this.parents    = parents.isEmpty() ? null : parents.toArray(new ClassDefinition[0]);
    }
    
    /**
@@ -714,6 +711,268 @@
    }
    
    /**
+    * Lookup or calculate the Java method name for a property or event and store the data for method
+    * name disambiguation. 
+    * 
+    * @param    node
+    *           The AST for which the method is being registered.
+    * @param    prefix
+    *           The accessor prefix.
+    * @param    lname
+    *           The legacy property/event name.
+    * @param    override
+    *           {@code true} if the property or event is overridden.
+    * @param    abstr
+    *           {@code true} if the property or event is abstract.
+    * @param    sig
+    *           The parameter definition.
+    *           
+    * @return   The Java method name that is associated with the specific property accessor.
+    */
+   public String registerPropertyMethod(Aast           node,
+                                        String         prefix, 
+                                        String         lname, 
+                                        boolean        override,
+                                        boolean        abstr,
+                                        ParameterKey[] sig)
+   {
+      String  accessor  = prefix + "-" + lname;
+      String  javaSig   = null;
+      String  legacySig = SymbolResolver.calculateLegacySignature(accessor, sig);
+      String  jparms    = SymbolResolver.calculateJavaParameters(sig);
+      String  key       = prefix + "-javaname";
+      String  javaname  = null;
+      
+      if (node.isAnnotation(key))
+      {
+         // subsequent time in, read the stored name from the AST and update the in memory storage
+         javaname = (String) node.getAnnotation(key);
+         
+         addJavaMethodName(javaname, jparms, legacySig);
+      }
+      else if (override)
+      {
+         // first time in (for an override)
+         javaname = lookupOverrideName(legacySig, override, false);
+         addJavaMethodName(javaname, jparms, legacySig);
+
+         node.putAnnotation(key, javaname);
+      }
+      else
+      {
+         if (abstr)
+         {
+            // abstract properties/events that match an interface property/event should get the same name
+            javaname = lookupOverrideName(legacySig, false, abstr);
+            
+            if (javaname != null)
+            {
+               addJavaMethodName(javaname, jparms, legacySig);
+            }
+         }
+
+         if (javaname == null)
+         {
+            // first time in (for a non-override), calculate the name and store it in memory and in the AST
+            javaname = calculateUniqueJavaMethodName(accessor, jparms, legacySig);
+         }
+         
+         node.putAnnotation(key, javaname);
+      }
+
+      return javaname;
+   }
+   
+   /**
+    * Compute the Java name for a legacy method which when combined with the Java parameter list will
+    * be a unique method name.
+    * 
+    * @param    name
+    *           The legacy name.
+    * @param    jparms
+    *           The Java parameter list definition.
+    * @param    legacySig
+    *           The legacy signature that will be mapped to the Java name.
+    *           
+    * @return   The Java name.
+    */
+   private String calculateUniqueJavaMethodName(String name, String jparms, String legacySig)
+   {
+      String jbase   = nconvert.convert(name, MatchPhraseConstants.TYPE_METHOD);
+      String jname   = jbase;
+      String javaSig = null;
+      
+      // TODO: the suffix can be replaced with something more verbose, to indicate i.e. the
+      // collision reason
+      int suffix = 1;
+      
+      while (true)
+      {
+         javaSig = jname + "(" + jparms + ")"; 
+         
+         if (!hasCollision(javaSig))
+         {
+            addJavaMethodName(jname, jparms, legacySig);
+            break;
+         }
+         
+         jname = jbase + "_" + suffix;
+         suffix++;
+      }
+
+      return jname;
+   }
+   
+   /**
+    * Check the current class and all parent classes/interfaces for a Java signature collision.
+    *  
+    * @param    javaSig
+    *           The Java method signature for which to check.
+    *           
+    * @return   {@code true} if there is a collision (an existing registered method with the same Java
+    *           signature).
+    */
+   private boolean hasCollision(String javaSig)
+   {
+      // quick out, fail if there is a local collision
+      if (javaMethodCollisions.contains(javaSig))
+      {
+         return true;
+      }
+      
+      java.util.function.Function<ClassDefinition, Boolean> collide = (ClassDefinition cls) ->
+      {
+         return cls.javaMethodCollisions.contains(javaSig);
+      };
+
+      // no local collision, but now we need to check our parent hierarchy
+      return calcFromParentGraph(collide, (Boolean value) -> !value, Boolean.FALSE, true, true);
+   }
+
+   /**
+    * Update the internal maps to record a new Java name.
+    * 
+    * @param    javaname
+    *           The Java method name to add.
+    * @param    jparms
+    *           The Java parameter list definition.
+    * @param    legacySig
+    *           The legacy signature that will be mapped to the Java name.
+    */
+   private void addJavaMethodName(String javaname, String jparms, String legacySig)
+   {
+      String javaSig = javaname + "(" + jparms + ")";
+
+      if (!javaMethodCollisions.contains(javaSig))
+      {
+         javaMethodCollisions.add(javaSig);
+      }
+      else
+      {
+         // don't uncomment this except for debugging; built-in classes (and others?) will trigger this
+         // System.err.printf("ERROR: Java signature %s already exists in collisions list.\n", javaSig);
+      }
+      
+      String old = legacyToJavaMethod.put(legacySig, javaname);
+      
+      if (old != null && !old.equals(javaname))
+      {
+         // something is wrong... name must match!
+         System.err.println("ERROR: method " + legacySig + 
+                            " accessible from class " + getName() + 
+                            " has two Java names: " + javaname + " and " + old);
+      }
+   }
+
+   /**
+    * Register this method signature with a converted Java method name.  The member data structure will
+    * have its javaname member set as a result of this call.  4 cases are handled (in this order):
+    * <p>
+    * <ol>
+    *    <li> The caller has passed in a non-null javaname.  This will force the name.
+    *    <li> The method is a overridden method, lookup the method in the parent class and use that name.
+    *    <li> The method signature is already registered, use the registered name.
+    *    <li> Calculate a unique name and register it.
+    * </ol>
+    * 
+    * @param    javaname
+    *           The javaname to forcibly assign to this legacy signature, or <code>null</code> to
+    *           compute an unique one.
+    * @param    mdat
+    *           The method definition.  Must NOT be {@code null}.
+    */
+   private void registerMethod(String javaname, MemberData mdat)
+   {
+      String jparms    = SymbolResolver.calculateJavaParameters(mdat.signature);
+      String legacySig = SymbolResolver.calculateLegacySignature(mdat.name, mdat.signature);
+      
+      // case 1: the caller knows best, if javaname is passed then force it here
+      if (javaname != null)
+      {
+         mdat.javaname = javaname;
+         addJavaMethodName(mdat.javaname, jparms, legacySig);         
+      }
+      
+      // case 2: overrides use the name of the parent (inheritance hierarchy)
+      else if (mdat.override)
+      {
+         mdat.javaname = lookupOverrideName(legacySig, mdat.override, false);
+         addJavaMethodName(mdat.javaname, jparms, legacySig);
+      }
+      
+      // case 3: the method is already registered with a unique name
+      else if (legacyToJavaMethod.containsKey(legacySig))
+      {
+         mdat.javaname = legacyToJavaMethod.get(legacySig);
+      }
+      
+      else
+      {
+         if (mdat.abstr)
+         {
+            // case 4: abstract methods that match an interface method should get the same name
+            mdat.javaname = lookupOverrideName(legacySig, false, mdat.abstr);
+            
+            if (mdat.javaname != null)
+            {
+               addJavaMethodName(mdat.javaname, jparms, legacySig);
+            }
+         }
+
+         if (mdat.javaname == null)
+         {
+            // case 5: not registered, calculate a unique name, avoiding signature conflicts
+            mdat.javaname = calculateUniqueJavaMethodName(mdat.name, jparms, legacySig);
+         }
+      }
+   }
+   
+   /**
+    * Lookup the Java method name in the parent/interface hierarchy for the given legacy signature.  The
+    * first match is returned.
+    *  
+    * @param    legacySig
+    *           The legacy signature.  This should uniquely identify a single method.
+    * @param    override
+    *           {@code true} is the method name is an override.  This will force a search of parent
+    *           (inheritance hierarchy).
+    * @param    abstr
+    *           {@code true} is the method name is abstract. This will force a search of any implemented
+    *           interfaces.
+    *           
+    * @return   The first Java name found for this legacy signature or {@code null} if there is no match.
+    */
+   private String lookupOverrideName(final String legacySig, boolean override, boolean abstr)
+   {
+      java.util.function.Function<ClassDefinition, String> oride = (ClassDefinition cls) ->
+      {
+         return cls.legacyToJavaMethod.get(legacySig);
+      };
+      
+      return calcFromParentGraph(oride, (String value) -> value == null, null, override, abstr);
+   }
+   
+   /**
     * Load the FWD implementation for a builtin, non-.NET class.  This maps legacy signatures to
     * Java method names, so that they will be reused for method references or override cases.
     */
@@ -721,9 +980,9 @@
    {
       Class<? extends _BaseObject_> cls = null;
 
-      javaClassName = SymbolResolver.findConvertedLegacyClass(name);
+      String fullname = SymbolResolver.findConvertedLegacyClass(name);
       
-      if (javaClassName == null)
+      if (fullname == null)
       {
          String clsPkg = (name.indexOf(".") < 0 ? "" : name.substring(0, name.lastIndexOf(".")));
          String clsName = clsPkg.isEmpty() ? name : name.substring(clsPkg.length() + 1);
@@ -758,16 +1017,18 @@
             clsName = "LegacyError";
          }
       
-         clsPkg = "com.goldencode.p2j.oo." + clsPkg + (clsPkg.isEmpty() ? "" : ".");
-         javaClassName = clsPkg + clsName;
+         javaPackage   = "com.goldencode.p2j.oo." + clsPkg;
+         javaClassName = clsName;
+         
+         fullname = javaPackage + "." + javaClassName;
 
          try
          {
-            cls = (Class<? extends _BaseObject_>) Class.forName(javaClassName);
+            cls = (Class<? extends _BaseObject_>) Class.forName(fullname);
          }
          catch (ClassNotFoundException e)
          {
-            System.err.println("Builtin class " + clsPkg + clsName + " is not implemented in FWD!");
+            System.err.println("Builtin class " + fullname + " is not implemented in FWD!");
             return;
          }
       }
@@ -775,11 +1036,16 @@
       {
          try
          {
-            cls = (Class<? extends _BaseObject_>) Class.forName(javaClassName);
+            cls = (Class<? extends _BaseObject_>) Class.forName(fullname);
+            
+            int dotIdx = fullname.lastIndexOf('.');
+            
+            javaPackage   = dotIdx < 0 ? "" : fullname.substring(0, dotIdx);
+            javaClassName = dotIdx < 0 ? fullname : fullname.substring(dotIdx + 1);            
          }
          catch (ClassNotFoundException e)
          {
-            System.err.println("Builtin class " + javaClassName + " is not implemented in FWD!");
+            System.err.println("Builtin class " + fullname + " is not implemented in FWD!");
             return;
          }
       }
@@ -821,7 +1087,7 @@
                      // c'tors only from the current definition
                      continue;
                   }
-                  String qname = getJavaSimpleName();
+                  String qname = getSimpleJavaName();
                   String qpkg = getJavaPackage().substring("com.goldencode.p2j.oo.".length());
                   qname = qpkg + "." + qname;
                   qname = qname.replace('.', '_');
@@ -832,21 +1098,10 @@
                   }
                   break;
             }
-            String legacySignature = computeLegacySignature(mname, lsig);
-            String jname = mthd.getName();
-            if (mname.equalsIgnoreCase("build"))
-            {
-               System.out.printf("LEGACY SIGNATURE %s %s %s\n", mname, legacySignature, jname);
-            }
+            String legacySig = SymbolResolver.calculateLegacySignature(mname, lsig);
+            String javaname  = mthd.getName();
             
-            String oldJname = javaMethodNames.put(legacySignature, jname);
-            if (oldJname != null && !oldJname.equals(jname))
-            {
-               // something is wrong... name must match!
-               System.err.println("ERROR: method " + legacySignature + 
-                                  " accessible from class " + clz + 
-                                  " has two Java names: " + jname + " and " + oldJname);
-            }
+            addJavaMethodName(javaname, "", legacySig);
          }
       };
 
@@ -899,60 +1154,23 @@
    }
    
    /**
-    * Given a Java method with a {@link LegacySignature}, compute its 4GL signature.
+    * Get the converted java method name for a method - this ensures the same Java name is used 
+    * for methods which are overridden, across the entire converted legacy classes.
+    * <p>
+    * Legacy methods for which there are collisions with the converted Java signatures, the names
+    * are made unique, but still ensures that any overridden versions will reuse the same name.
     * 
-    * @param    mname
-    *           The legacy method name.
-    * @param    lsig
-    *           The legacy signature annotation.
+    * @param    legacy
+    *           The legacy name.
+    * @param    mAst
+    *           The method definition AST.
+    *           
+    * @return   The converted Java name to use for this legacy method.
     */
-   public static String computeLegacySignature(String mname, LegacySignature lsig)
+   public String getConvertedMethodName(String legacy, Aast mAst)
    {
-      String legacySignature = mname.toLowerCase() + "(";
-      for (LegacyParameter lparam : lsig.parameters())
-      {
-         String pmode = lparam.mode();
-         if ("INPUT".equals(pmode))
-         {
-            pmode = ProgressParser.lookupTokenName(KW_INPUT);
-         }
-         else if ("OUTPUT".equals(pmode))
-         {
-            pmode = ProgressParser.lookupTokenName(KW_OUTPUT);
-         }
-         else if ("INPUT-OUTPUT".equals(pmode))
-         {
-            pmode = ProgressParser.lookupTokenName(KW_IN_OUT);
-         }
-         
-         String ptype = lparam.type().toLowerCase();
-         if ("bdt".equals(ptype))
-         {
-            // OO legacy classes which have POLY parameters have BDT as their type, at the Java implementation.
-            ptype = "Object";
-         }
-         
-         String psig = pmode + " " + ptype;
-         if (!lparam.qualified().isEmpty())
-         {
-            psig = psig + "<? extends " + lparam.qualified().toLowerCase() + ">";
-         }
-         else if ("object".equalsIgnoreCase(lparam.type()))
-         {
-            psig = psig + "<? extends progress.lang.object>";
-         }
-         if (lparam.extent() == -1)
-         {
-            psig = psig + "[]";
-         }
-         else if (lparam.extent() != -2)
-         {
-            psig = psig + "[" + lparam.extent() + "]";
-         }
-         legacySignature = legacySignature + (legacySignature.endsWith("(") ? "" : ", ") + psig;
-      }
-      
-      return legacySignature + ")";
+      ParameterKey[] signature = SymbolResolver.calculateDefinitionSignature(mAst);
+      return getConvertedMethodName(SymbolResolver.calculateLegacySignature(legacy, signature));
    }
 
    /**
@@ -965,9 +1183,9 @@
     */
    public String getConvertedMethodName(String legacySig)
    {
-      if (javaMethodNames.get(legacySig) != null)
+      if (legacyToJavaMethod.get(legacySig) != null)
       {
-         return javaMethodNames.get(legacySig);
+         return legacyToJavaMethod.get(legacySig);
       }
       
       if (parents != null)
@@ -982,7 +1200,7 @@
             }
          }
       }
-      
+
       return null;
    }
 
